package nc.bs.bd.bom.bom0202.pfxx.plugin;

import java.text.SimpleDateFormat;
import java.util.Date;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.pfxx.ISwapContext;
import nc.itf.bd.bom.bom0202.IBomBillMaintainService;
import nc.itf.uap.pf.IPFBusiAction;
import nc.vo.bd.bom.bom0202.entity.AggBomVO;
import nc.vo.bd.bom.bom0202.entity.BomUseOrgVO;
import nc.vo.bd.bom.bom0202.entity.BomVO;
import nc.vo.pfxx.auxiliary.AggxsysregisterVO;
import nc.vo.pfxx.util.PfxxPluginUtils;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.VOStatus;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.pubapp.pattern.pub.PubAppTool;

/**
 * <b> ڴ˴ҪĹ </b>
 * <p>
 * ڴ˴ӴϢ
 * </p>
 * 
 * @author ufsoft
 * @version Your Project V60
 */
public class MMbdBomPfxxPlugin extends nc.bs.pfxx.plugin.AbstractPfxxPlugin {

    private IBomBillMaintainService service = null;

    private IBomBillMaintainService getiBomBillMaintainService() {
        if (this.service == null) {
            this.service = NCLocator.getInstance().lookup(IBomBillMaintainService.class);
        }
        return this.service;

    }

    /**
     * XMLתVONCϵͳҵʵִ˷ɡ<br>
     * ע⣬ҵ񷽷УһҪ
     * 
     * @param vo
     *            תvoݣNCϵͳпΪValueObject,SuperVO,AggregatedValueObject,IExAggVOȡ
     * @param swapContext
     *            ֽܷ֯ͷ׵ȵ
     * @param aggxsysvo
     *            Ϣvo
     * @return
     * @throws BusinessException
     */
    @Override
    protected Object processBill(Object vo, ISwapContext swapContext, AggxsysregisterVO aggxsysvo)
            throws BusinessException {

        // 1.õתVO,ȡ򵼵һעVOϢ
        AggregatedValueObject resvo = (AggregatedValueObject) vo;

        // 2.ѯ˵ǷѾʹһο˵javadoc
        String vopk = PfxxPluginUtils.queryBillPKBeforeSaveOrUpdate(swapContext.getBilltype(), swapContext.getDocID());

        // 3. иϢaggxsysvoΪûõľ帨Ϣ

        // 4.˵ûеô׼µݣ浥ǰбҪݼ飬ȷҵ쳣...
        AggregatedValueObject returnVO = null;

        // ݼ߼
        // this.checkBill(resvo);

        if (PubAppTool.isNull(vopk)) {
            resvo.getParentVO().setStatus(VOStatus.NEW);
            for (CircularlyAccessibleValueObject bvo : resvo.getChildrenVO()) {
                bvo.setStatus(VOStatus.NEW);
            }
            
    		try {
    			// ߳ҵ
    			SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    			Object dateTimeString  = resvo.getParentVO().getAttributeValue("tmaketime");
    			if(dateTimeString != null) {
    				Date date = format.parse(dateTimeString.toString());
    				long timestamp = date.getTime();
    				InvocationInfoProxy.getInstance().setBizDateTime(timestamp);
    			}
    		} catch (Exception e) {
    			ExceptionUtils.wrappException(e);
    		}
            AggBomVO  aggBomVO = (AggBomVO) resvo;
            BomVO bomVO = (BomVO) resvo.getParentVO();
            BomUseOrgVO bomUseOrgVO = new BomUseOrgVO();
            bomUseOrgVO.setPk_useorg(bomVO.getPk_org());
            aggBomVO.setChildren(BomUseOrgVO.class, new BomUseOrgVO[] {bomUseOrgVO});
            returnVO = this.getiBomBillMaintainService().insertBom(new AggBomVO[] {
                (AggBomVO) resvo
            })[0];
            NCLocator.getInstance().lookup(IPFBusiAction.class) .processBatch("APPROVE", "19B1",new AggBomVO[] {(AggBomVO) returnVO}, null, null, null);
        }
        else {
            // 5.˵ѾPfxxPluginUtils.checkBillCanBeUpdate(UfinterfaceVO
            // swapContext)鵥Ƿ
            // ,˷׳ҵ쳣
            // PfxxPluginUtils.checkBillCanBeUpdate(swapContext);
            returnVO = this.getiBomBillMaintainService().updateBom(new AggBomVO[] {
                (AggBomVO) resvo
            })[0];
        }
        vopk = returnVO.getParentVO().getPrimaryKey();
        // 6.ϣݽԸ£нӿڲĵˮPKĶչϵ
        PfxxPluginUtils.addDocIDVsPKContrast(swapContext.getBilltype(), swapContext.getDocID(), vopk);

        // 7.׼ֵ,˺ķֵջַʽظϵͳ
        // ͨݿԷNCϵͳɵPKֵƾ֤ܷƾ֤ţӵݶ
        // ڲѯҪ󷵻org.w3c.dom.Node[] org.w3c.dom.Node
        return vopk;

    }

}
